Option Explicit
'These are the date/time conversion routines

'STANDARD OBS FILE... DO NOT CHANGE

'modified 7/27/93 for 1970 dates. Use function+00 for 1900 dates
'modified 9/27/93 for server time
'DateKey   processes +/- keys for date changes
'DTSDrive  return date serial number for given drive letter (uses STIME.DLL)
'DTSLong   returns date serial number from long integer w/ 1/1/70 base
'DTSLong00 returns date serial number from long integer w/ 1/1/00 base
'DTSSer    returns date serial number from formatted string
'DTSStr    returns formatted string from date serial number
'DTSWk     returns date serial number for a week#
'FixDTS    formats a DTS listbox contents with formatted date
'GetDTS    returns date serial number from hex string
'GetDTS00  returns date serial number from hex string w/ 1/1/00 base
'LongDTS   returns long integer from date serial number
'LongDTS00 returns long integer from date serial number w/ 1/1/00 base
'PutDTS    returns hex string from date serial number
'PutDTS00  returns hex string from date serial number w/ 1/1/00 base
'SOTKEY    returns Sun Optech key as 8 character string for current given drive letter
'SOTKEY00  returns Sun Optech key as 8 character string for current given drive letter
'StrIntl
'WkStr     returns wk/yr string for wk1=first Monday


'types for STIME.DLL used for server time
Type OBData
    sos As Long';........................not used
    sot_tz As Long';...........................global timezone variable
    sot_UTC_diff As Long';...................minutes difference from this machine to UTC
    SOTKEY As Long';..........................long from time call
    tflg As Integer';..................................request code
    sot_daylight As Integer';..............Daylight savings Yes of No
    sot_tzname As String * 4';...............timezone name
    sot_uk As String * 10';....................SunOpTech unique key
    Drive As String * 5';.........................Disk drive
    ermsg As String * 64';.....................Error message
End Type
Global SOTTime As OBData

Type OBNum
    sot_code As String * 4';................request code.
    sot_num As String * 20';...............number to be converted.
    sot_strnum As String * 64';...........string number represention of converted number.
End Type
Global SOTNum As OBNum

Declare Function StimeSearch Lib "stime.dll" (SOTTime As OBData, ByVal Hwnd%) As Integer
Declare Function sqtimesearch Lib "stime.dll" (SOTTime As OBData) As Integer
Declare Function SnumConvert Lib "stime.dll" (SOTTime As OBNum) As Integer

Global DateFormat As String
Global UTCHrs As Integer
Global DAYLIGHTSAVINGS As Integer

Sub DateKey (KeyAscii As Integer, Ctrl As Control)
'here trap +/- for date change (general rtn w/ activecontrol?)
'use SelStart to decide to add month, hour, etc.
'If TypeOf Ctrl Is Textbox Then
Dim s$, DateText#
    s$ = Ctrl
    Select Case KeyAscii
    Case 43 '+
    If IsDate(Ctrl) Then
        DateText# = DTSSer(s$)
        DateText# = DateText# + 1
        Ctrl = DTSStr(DateText#)
    End If
    KeyAscii = 0
    Case 45 '-
    If IsDate(Ctrl) Then
        DateText# = DTSSer(s$)
        DateText# = DateText# - 1
        Ctrl = DTSStr(DateText#)
    End If
    KeyAscii = 0
    End Select
'End If
End Sub

Function DTSDrive (D$) As Double
'get time from drive and converts to serial
Dim NewTime As Long, OldDrive$
OldDrive$ = CurDir$
SOTTime.Drive = Left$(D$, 1)
If sqtimesearch(SOTTime) Then
'now convert for INI time zone
    'first backout adjustments to get machine time
    NewTime = SOTTime.SOTKEY - SOTTime.sot_tz + SOTTime.sot_daylight * 3600
    'then adjust for our INI time
    NewTime = NewTime + UTCHrs * 3600 + DAYLIGHTSAVINGS * 3600
    DTSDrive = DTSLong(NewTime)
End If
ChDrive OldDrive$   'change back to old drive
End Function

Function DTSLong (l&) As Double
'returns date serial number from long integer
DTSLong = l& / 86400 + 25569
End Function

Function DTSLong00 (l&) As Double
'returns date serial number from long integer
DTSLong00 = (l& + 4294967295#) / 86400 + 1
End Function

Function DTSSer (s$) As Double
'returns date serial number from formatted string
'*** allow entry/display of date string as wk/yr?
    If IsDate(s$) Then DTSSer = DateValue(s$) + TimeValue(s$)
    If IsNumeric(s$) Then
        If CInt(s$) > 0 And CInt(s$) < 54 Then 'may be week#
            DTSSer = DTSWk(CInt(s$), 0)
        End If
    End If
End Function

Function DTSStr (T#) As String
'returns formatted string for date serial number
'change this to read WIN.INI and get format?
'uses global DATEFORMAT variable read from INI
Dim DF$

If Len(DateFormat) Then
    DF$ = UCase$(DateFormat)
Else
    DF$ = "Medium Date"
End If
If DF$ = "WEEK" Then 'need special rtn for week w/ Monday start
    DTSStr = WkStr(T#)
ElseIf T# = 0 Then 'CRB 05/05/94
    DTSStr = ""
Else
    DTSStr = Format$(T#, DF$)'convert to seconds from 1/1/00 00:00:00
End If
End Function

Function DTSWk (wk, yr) As Double
'DTSWk  returns date serial number for a given week# and year
'first set yr (default current year)
    If yr = 0 Then yr = Year(Now)
    '*** US Method for week by first Monday
    'then find first Monday
    'While wkday <> 2
    '    dy = dy + 1
    '    Day1# = DateValue("1/" + cstr(dy) + "/" + cstr(yr))
    '    wkday = Weekday(Day1#)
    'Wend
    'ISO (europe) method by 1/4
    Dim dy As Integer, Day1#, wkday%
    dy = 4
    Day1# = DateValue(CStr(dy) + "-JAN-" + CStr(yr))
    While wkday% <> 2
        wkday% = Weekday(Day1#)
        Day1# = Day1# - 1
    Wend
    'then  add # of weeks
    DTSWk = Day1# + 7 * (wk - 1)
End Function

Sub FixDTS (Ctrl As Control)
'formats a DTS listbox contents with formatted date
Dim i%, s$
For i% = 0 To Ctrl.ListCount - 1
    s$ = Ctrl.List(i%)
    Ctrl.List(i) = DTSStr(GetDTS(s$))
Next
End Sub

Function GetDTS (H$) As Double
'returns date serial number from hex string
Dim TempH$, pos&    'add pos& check 5/11/94 CRB
On Error Resume Next
TempH$ = Trim_nul(H$) 'CRB 05/05/94
If Len(TempH$) Then
    pos& = InStr(TempH$, ".")
    If pos& Then TempH$ = Left$(TempH$, pos& - 1)
    If Len(TempH$) > 8 Then TempH$ = Left$(TempH$, 8)
    GetDTS = (CDbl("&H" + TempH$)) / 86400 + 25569
    If Err = 13 Then GetDTS = 0
End If
End Function

Function GetDTS00 (H$) As Double
'returns date serial number from hex string
GetDTS00 = (CDbl("&H" + H$) + 4294967296#) / 86400 + 1
End Function

Function GetDTS90 (H$) As Double
'returns date serial number from hex string based on 1990 base date
Dim TempH$, pos&    'add pos& check 5/11/94 CRB
On Error Resume Next
TempH$ = Trim_nul(H$) 'CRB 05/05/94
If Len(TempH$) Then
    pos& = InStr(TempH$, ".")
    If pos& Then TempH$ = Left$(TempH$, pos& - 1)
    If Len(TempH$) > 8 Then TempH$ = Left$(TempH$, 8)
    GetDTS90 = (CDbl("&H" + TempH$)) / 86400 + 25569 + 7305
    If Err = 13 Then GetDTS90 = 0
End If

End Function

Function LongDTS (T#) As Long
'returns long integer for date serial number
If T# = 0 Then
    LongDTS = 0
Else
    LongDTS = CLng((T# - 25569) * 86400) 'convert to seconds from 1/1/70 00:00:00
End If
End Function

Function LongDTS00 (T#) As Long
'returns long integer for date serial number
LongDTS00 = CLng((T# - 1) * 86400 - 4294967295#)'convert to seconds from 1/1/00 00:00:00
End Function

Function longdts94 (T#) As Long
'returns long integer for date serial number
longdts94 = CLng((T# - (34335)) * 86400)'convert to seconds from 1/1/90 00:00:00
End Function

Function PutDTS (T#) As String
    If T# > 25569 Then PutDTS = Hex$(CLng((T# - 25569) * 86400))'convert to seconds from 1/1/70 00:00:00
End Function

Function PutDTS00 (T#) As String
'returns hex string for date serial number
If T# > 24857 Then PutDTS00 = Hex$(CLng((T# - 1) * 86400 - 4294967295#))'convert to seconds from 1/1/00 00:00:00
End Function

Function SOTKEY (D$) As String
'returns Sun Optech key as 8 character string for current DTS of drive D$
SOTKEY = PutDTS(DTSDrive(D$))    'convert to seconds from 1/1/70 00:00:00
End Function

Function SOTKEY00 (D$) As String
'returns Sun Optech key as 8 character string for current DTS
SOTKEY00 = PutDTS(DTSDrive(D$))     'convert to seconds from 1/1/00 00:00:00
End Function

Function StrINTL (T!) As String
'returns with leading zero
End Function

Function WKDTS (T#) As Integer
'returns week # from serial number
    Dim Day1#
    Day1# = DTSWk(1, Year(T#))
    WKDTS = ((T# - Day1#) \ 7 + 1)
End Function

Function WkStr (T#) As String
'returns wk/yr for wk1=first Monday
'first find serial for first Monday
    Dim Day1#
    Day1# = DTSWk(1, Year(T#))
    WkStr = "W " + Format$((T# - Day1#) \ 7 + 1, "00") + "/" + Format$(T#, "yy")
End Function

