Attribute VB_Name = "Module1"
Option Explicit

#If Win32 Then

    Declare Function SystemParametersInfo Lib "user32" _
        Alias "SystemParametersInfoA" (ByVal uAction As Long, _
        ByVal uParam As Long, ByVal lpvParam As String, _
        ByVal fuWinIni As Long) As Long

    Declare Function GIF2BMP Lib "gifbmp32.dll" _
        Alias "GIFTOBMP32" (ByVal lpstrGIF As String, _
        ByVal lpstrBMP As String) As Integer

    Declare Function GetPrivateProfileString Lib "kernel32" Alias _
        "GetPrivateProfileStringA" (ByVal lpApplicationName As String, _
        ByVal lpKeyName As Any, ByVal lpDefault As String, _
        ByVal lpReturnedString As String, ByVal nSize As Long, _
        ByVal lpFileName As String) As Long

    Declare Sub WritePrivateProfileString Lib "kernel32" Alias _
        "WritePrivateProfileStringA" (ByVal lpApplicationName As String, _
        ByVal lpKeyName As String, ByVal lpString As String, ByVal lpFileName As String)


#ElseIf Win16 Then

    Declare Function SystemParametersInfo Lib "User" (ByVal uAction As Integer, _
        ByVal uParam As Integer, lpvParam As Any, ByVal fuWinIni As Integer) _
        As Integer

    Declare Function GIF2BMP Lib "giftobmp.dll" Alias "GIFToBMP" _
        (ByVal lpstrGIF As String, ByVal lpstrBMP As String) As Integer

    Declare Function GetPrivateProfileString Lib "Kernel" (ByVal _
        lpApplicationName As String, lpKeyName As Any, ByVal lpDefault As String, _
        ByVal lpReturnedString As String, ByVal nSize As Integer, _
        ByVal lpFileName As String) As Integer

    Declare Sub WritePrivateProfileString Lib "Kernel" (ByVal lpApplicationName _
        As String, lpKeyName As String, lpString As String, ByVal lplFileName As String)


#End If

Type LinkType
    Title       As String
    Link        As String
    LinkType    As Integer
End Type
Global LinkArray() As LinkType

Global Const LINKTYPE_GOPHER_GIF = 1
Global Const LINKTYPE_GOPHER_BMP = 2
Global Const LINKTYPE_WEB_GIF = 3
Global Const LINKTYPE_WEB_BMP = 4

Sub szParseURL(szURL As String, szHost As String, lPort As Long, szPath As String)

    Dim nPos        As Integer
    Dim nSpace      As Integer
    Dim szFile      As String
    Dim szUrlSave   As String
    Dim nWebType    As Integer
    Dim nOffSet     As Integer
    
    szUrlSave = szURL
    
    nPos = InStr(UCase$(szURL), "HTTP://")
    If nPos = 0 Then
        nPos = InStr(UCase$(szURL), "FILE://")
        If nPos = 0 Then
            nPos = InStr(UCase$(szURL), "GOPHER://")
            If nPos Then
                lPort = 70
                nOffSet = 9
            End If
        Else
            lPort = 80
            nWebType = True
            nOffSet = 7
        End If
    Else
        lPort = 80
        nWebType = True
        nOffSet = 7
    End If
    
    If nPos Then
        '-- Return the URL starting from the server
        '   name
        szURL = Mid$(szURL, nPos + nOffSet)

        '-- Find the next slash.
        nPos = InStr(szURL, "/")
        If nPos Then
            '-- Pull the address
            szHost = Left$(szURL, nPos - 1)
            '-- Is a port specified?
            nSpace = InStr(szHost, ":")
            If nSpace Then
                '-- Yes. Return it
                lPort = Val(Mid$(szHost, nSpace + 1))
                szHost = Left$(szHost, nSpace - 1)
            End If

            '-- Return the URL starting with the
            '   path
            szPath = Mid$(szURL, nPos)
        End If
    End If

    If nWebType Then
        szPath = "GET " & szPath
    Else
        If Left$(UCase$(szPath), 3) = "/I9" Then
            szPath = Mid$(szPath, 3)
        End If
    End If
    
    szURL = szUrlSave

End Sub


